<template>
    <split id="usr2calendarexpviewcalendarexpbar" class="app-calendar-exp-bar" v-model="split" mode="horizontal" @on-move-end="onSplitChange">
        <div slot='left'>
            <div class='calendar-exp-bar-header'>
                <div><icon type='ios-home-outline'/>{{ $t('app.calendarExpBar.title') }}</div>
            </div>
           <div class="container-header">
           </div>
            <div class='calendar-exp-bar-content'>
                <view_calendarexpbar_calendar 
    :viewState="viewState"  
    :viewparams="viewparams" 
    :context="context" 
    :showBusyIndicator="true"
    :isSelectFirstDefault="true"
    :newdata="newdata"
    :opendata="opendata"
    name="calendarexpbar_calendar"  
    ref='calendarexpbar_calendar' 
    @selectionchange="calendarexpbar_calendar_selectionchange($event)"  
    @load="calendarexpbar_calendar_load($event)"  
    @closeview="closeView($event)">
</view_calendarexpbar_calendar>
            </div>
        </div>
        <div slot='right'>
            <component 
              v-if="selection.view && !Object.is(this.selection.view.viewname, '')" 
              :is="selection.view.viewname"
              class="viewcontainer2"
              :viewDefaultUsage="false"
              :viewdata="JSON.stringify(selection.context)"
              :viewparam="JSON.stringify(selection.viewparam)">
            </component>
        </div>
    </split>
</template>


<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZOrderService from '@/service/ibizorder/ibizorder-service';
import Usr2CalendarExpViewcalendarexpbarService from './usr2-calendar-exp-viewcalendarexpbar-calendarexpbar-service';
import IBIZOrderUIService from '@/uiservice/ibizorder/ibizorder-ui-service';


@Component({
    components: {
      
    }
})
export default class Usr2CalendarExpViewcalendarexpbarBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public getControlType(): string {
        return 'CALENDAREXPBAR'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Usr2CalendarExpViewcalendarexpbarService}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public service: Usr2CalendarExpViewcalendarexpbarService = new Usr2CalendarExpViewcalendarexpbarService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZOrderService}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public appEntityService: IBIZOrderService = new IBIZOrderService({ $store: this.$store });

    /**
     * calendarexpbar_calendar 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_calendar_selectionchange($event: any, $event2?: any) {
        this.calendarexpbar_selectionchange($event, 'calendarexpbar_calendar', $event2);
    }

    /**
     * calendarexpbar_calendar 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_calendar_load($event: any, $event2?: any) {
        this.calendarexpbar_load($event, 'calendarexpbar_calendar', $event2);
    }
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  Usr2CalendarExpViewcalendarexpbarBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }




    /**
     * 视图唯一标识
     *
     * @type {boolean}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop() public viewUID!:string;

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop() public opendata: any;

    /**
     * 是否单选
     * 
     * @public
     * @type {(boolean)}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public isSingleSelect:boolean = true;

    /**
     * 呈现模式，可选值：horizontal或者vertical
     * 
     * @public
     * @type {(string)}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public showMode:string ="horizontal";

    /**
     * 控件宽度
     *
     * @type {number}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public ctrlWidth:number = 0;

    /**
     * 控件高度
     *
     * @type {number}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public ctrlHeight: number = 0;

    /**
     * 可搜索字段名称
     * 
     * 
     * @type {(string)}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public placeholder="订单名称";

    /**
     * 搜素值
     * 
     * @public
     * @type {(string)}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public searchText:string = "";

    /**
     * 分割宽度
     *
     * @type {number}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public split: number = 0.5;


    /**
     * 导航视图名称
     *
     * @type {string}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public navViewName: any = {
        item1: "ibizorder-detail-sgrid-view9"
    };

    /**
     * 导航参数
     *
     * @type {*}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public navParam: any = {
        item1: {
            navigateContext:null,
            navigateParams:null
        }
    };

    /**
     * 导航过滤项
     *
     * @type {*}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public navFilter: any = {
        item1: ""
    };

    /**
     * 导航关系
     *
     * @type {*}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public navPSDer: any = {
        item1: "n_ibizorderid_eq"
    };

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    @Prop({ default: true }) public showBusyIndicator!: boolean;


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public getData(): any {
        return null;
    }

    /**
     * 选中数据
     *
     * @type {*}
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public selection: any = {};

    /**
     * split值变化事件
     *
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public onSplitChange() {
        if(this.$refs.calendarexpbar_calendar){
            const calendarContainer:any = this.$refs.calendarexpbar_calendar;
            if(calendarContainer.$refs.calendar){
                const appCalendar: any = calendarContainer.$refs.calendar;
                const api = appCalendar.getApi();
                api.updateSize();
            }
        }
        if(this.split){
          this.$store.commit("setViewSplit",{viewUID:this.viewUID,viewSplit:this.split});
        }
    }

    /**
    * Vue声明周期(组件初始化完毕)
    *
    * @memberof Usr2CalendarExpViewcalendarexpbarBase
    */
    public created() {
         this.afterCreated();     
    }

    /**
    * 执行created后的逻辑
    *
    * @memberof Usr2CalendarExpViewcalendarexpbarBase
    */
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                this.viewState.next({ tag: 'calendarexpbar_calendar', action: action, data: data });
            });
        }  
    }
    
    /**
    * Vue声明周期(组件渲染完毕)
    *
    * @memberof Usr2CalendarExpViewcalendarexpbarBase
    */
    public mounted() {
        this.afterMounted();     
    }

    /**
    * 执行mounted后的逻辑
    *
    * @memberof Usr2CalendarExpViewcalendarexpbarBase
    */
    public afterMounted(){ 
        if(this.$store.getters.getViewSplit(this.viewUID)){
            this.split = this.$store.getters.getViewSplit(this.viewUID);
        }else{
            let containerWidth:number = (document.getElementById("usr2calendarexpviewcalendarexpbar") as any).offsetWidth;
            let containerHeight:number = (document.getElementById("usr2calendarexpviewcalendarexpbar") as any).offsetHeight;
            if(Object.is(this.showMode,'horizontal')){
                if(this.ctrlWidth){
                    this.split = this.ctrlWidth/containerWidth;
                }
            }else{
                if(this.ctrlHeight){
                    this.split = this.ctrlHeight/containerHeight;
                }
            }
            this.$store.commit("setViewSplit",{viewUID:this.viewUID,viewSplit:this.split}); 
        }  
    }
 
    /**
     * vue 生命周期
     *
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }

    /**
    * 刷新
    *
    * @memberof Usr2CalendarExpViewcalendarexpbarBase
    */
    public refresh(args?: any): void {
        const refs: any = this.$refs;
        if (refs && refs.calendarexpbar_calendar) {
            refs.calendarexpbar_calendar.refresh();
        }
    }

    /**
     * calendarexpbar的选中数据事件
     * 
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_selectionchange(args: any [], tag?: string, $event2?: any): void {
        let tempContext:any = {};
        let tempViewParam:any = {};
        if (args.length === 0) {
            this.calcToolbarItemState(true);
            return ;
        }
        const arg:any = args[0];
        if(this.context){
            Object.assign(tempContext,JSON.parse(JSON.stringify(this.context)));
        }
        switch(arg.itemType) {
            case "item1":
                Object.assign(tempContext,{ ibizorder : arg.ibizorder});
                Object.assign(tempContext,{srfparentdename:'IBIZOrder',srfparentkey:arg['ibizorder']});
                if(this.navFilter && this.navFilter['item1'] && !Object.is(this.navFilter['item1'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['item1']]:arg['ibizorder']});
                }
                if(this.navPSDer && this.navFilter['item1'] && !Object.is(this.navPSDer['item1'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['item1']]:arg['ibizorder']});
                }
                if(this.navParam && this.navParam['item1'] && this.navParam['item1'].navigateContext && Object.keys(this.navParam['item1'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['item1'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['item1'] && this.navParam['item1'].navigateParams && Object.keys(this.navParam['item1'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['item1'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
        }
        this.selection = {};
        Object.assign(this.selection, { view: { viewname: this.navViewName[arg.itemType] }, context:tempContext,viewparam:tempViewParam });
        this.calcToolbarItemState(false);
        this.$emit('selectionchange',args);
        this.$forceUpdate();
    }

    /**
     * calendarexpbar的load完成事件
     * 
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_load(args:any, tag?: string, $event2?: any){
        this.calcToolbarItemState(true);
        this.$emit('load',args);
    }

    /**
     * 设置导航区工具栏禁用状态
     *
     * @param {boolean} state
     * @return {*} 
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public calcToolbarItemState(state: boolean) {
        let _this: any = this;
        const models:any = _this.usr2calendarexpviewcalendarexpbar_toolbarModels;
        if (models) {
            for (const key in models) {
                if (!models.hasOwnProperty(key)) {
                    return;
                }
                const _item = models[key];
                if (_item.uiaction && (Object.is(_item.uiaction.target, 'SINGLEKEY') || Object.is(_item.uiaction.target, 'MULTIKEY'))) {
                    _item.disabled = state;
                }
                _item.visabled = true;
                if (_item.noprivdisplaymode && _item.noprivdisplaymode === 6) {
                    _item.visabled = false;
                }
            }
            this.calcNavigationToolbarState();
        }
    }

    /**
     * 计算导航工具栏权限状态
     * 
     * @memberof Usr2CalendarExpViewcalendarexpbarBase
     */
    public calcNavigationToolbarState(){
        let _this: any = this;
        // 界面行为
        if(_this.usr2calendarexpviewcalendarexpbar_toolbarModels){
            const curUIService:IBIZOrderUIService  = new IBIZOrderUIService();
            ViewTool.calcActionItemAuthState({},_this.usr2calendarexpviewcalendarexpbar_toolbarModels,curUIService);
        }
    }

    /**
    * 执行搜索
    *
    * @memberof Usr2CalendarExpViewcalendarexpbarBase
    */
    public onSearch($event:any) {
        let calendar:any = this.$refs.calendarexpbar_calendar;
        calendar.searchEvents({ query: this.searchText });
    }

}
</script>

<style lang='less'>
@import './usr2-calendar-exp-viewcalendarexpbar-calendarexpbar.less';
</style>